<?php
namespace Utility;


/**
 * File data storage functionality.
 * @author andre.fourie
 */
class FileStore
{


    /**
     * Store data to file.
     * @param  string  $key  Storage key
     * @param  unknown $data Data to store
     * @return void
     */
    static public function existsJson($key)
    {
        return file_exists(getcwd() . '/data/file/' . $key . '.json');
    }

    /**
     * Store data to file.
     * @param  string $key  Storage key
     * @param  array  $data Data to store
     * @return void
     */
    static public function storeJson($key, $data)
    {
        file_put_contents(getcwd() . '/data/file/' . $key . '.json', json_encode($data));
    }

    /**
     * Retrieve data from file.
     * @param  string  $key Storage key
     * @return unknown      Stored data or null
     */
    static public function fetchJson($key)
    {
        if (!file_exists(getcwd() . '/data/file/' . $key . '.json'))
        {
            return null;
        }
        $result = file_get_contents(getcwd() . '/data/file/' . $key . '.json');
        return json_decode($result, true);
    }

    /**
     * Delete data file.
     * @param  string  $key Storage key
     * @return void
     */
    static public function deleteJson($key)
    {
        if (file_exists(getcwd() . '/data/file/' . $key . '.json'))
        {
            unlink(getcwd() . '/data/file/' . $key . '.json');
        }
    }

    /**
     * Store data to file.
     * @param  string  $key  Storage key
     * @param  unknown $data Data to store
     * @return void
     */
    static public function storeText($key, $data)
    {
        file_put_contents(getcwd() . '/data/file/' . $key . '.txt', $data);
    }

    /**
     * Retrieve data from file.
     * @param  string  $key Storage key
     * @return unknown      Stored data or null
     */
    static public function fetchText($key)
    {
        if (!file_exists(getcwd() . '/data/file/' . $key . '.txt'))
        {
            return null;
        }
        return file_get_contents(getcwd() . '/data/file/' . $key . '.txt');
    }

    /**
     * Delete data file.
     * @param  string  $key Storage key
     * @return void
     */
    static public function deleteText($key)
    {
        if (file_exists(getcwd() . '/data/file/' . $key . '.txt'))
        {
            unlink(getcwd() . '/data/file/' . $key . '.txt');
        }
    }



}